#version 430 core

// Input variables
in VertexData
{
	vec2 tex_coord;
} inData;

// Output variables
layout (location = 0) out vec4 final_color;

//input textures
layout (binding = 0) uniform sampler2D lit_scene;
layout (binding = 1) uniform sampler2D blurred_highlights;

uniform float exposure;
uniform float gamma;

// TASK 5 - bloom effect

void main()
{
	// combine lit scene with blurred highlights - simple additive blending
    vec3 hdrColor = texture(lit_scene, inData.tex_coord).rgb;      
    hdrColor += texture(blurred_highlights, inData.tex_coord).rgb; 
    
	// tone mapping
    vec3 result = vec3(1.0) - exp(-hdrColor * exposure);
    
	// also gamma correction while we're at it       
    result = pow(result, vec3(1.0 / gamma));
    final_color = vec4(result, 1.0f);
}