#version 430 core

// Input variables
in VertexData
{
	vec2 tex_coord;
} inData;

// Output variables
layout (location = 0) out vec4 final_blurred_highlight;

// texture to be blurred
layout (binding = 0) uniform sampler2D highlights_texture;


//TASK 4 - Blur input texture
//		- kernel size? Start with 5x5
//		- tip: we want to spread bright pixel... usage of max()

// Kernel for blurring
const float kernel[5] = float[5](1.0, 1.0, 1.0, 1.0, 1.0);
const float kernel_sum = 5.0 * 5.0;


void main()
{
	// Simple average blur
	vec2 texel_size = 1.0 / textureSize(highlights_texture, 0);		// Size of one texel when texture coordinates are in range (0,1)
	vec3 sum = vec3(0.0);

	for (int x = 0; x < kernel.length(); x++)
	{
		for (int y = 0; y < kernel.length(); y++)
		{
			// Offset from the center texel
			vec2 offset = texel_size * (vec2(x, y) - vec2(kernel.length()/2));

			// Adding weighted value
			sum += kernel[x] * kernel[y] * textureLod(highlights_texture, inData.tex_coord + offset, 0).rgb;
		}
	}	

	vec3 col = sum /kernel_sum;
	final_blurred_highlight = vec4(max(textureLod(highlights_texture, inData.tex_coord, 0).rgb, col), 1.0);
}
