#version 430 core

// Input variables
in VertexData
{
	vec2 tex_coord;
} inData;

// Output variables
layout (location = 0) out vec4 final_color;

// Texture to display and a transformation to be applied to the colors of the texture
layout (binding = 0) uniform sampler2D input_tex;
uniform float exposure;
uniform float gamma;

void main()
{
	// TASK 2 - Tone mapping 
	//		- try different methods
	//		- don't forget to pass necessary parameters

	vec3 hdrColor = texture(input_tex, inData.tex_coord).rgb;

	// TASK 2 a) Reinhard mapping
	//vec3 mapped = hdrColor / (hdrColor + vec3(1.0));


	// TASK 2 b) exposure mapping
    // Exposure tone mapping
    vec3 mapped = vec3(1.0f) - exp2(-hdrColor * exposure);
    
	// TASK 2 c) exposure mapping
	// Gamma correction 
    mapped = pow(mapped, vec3(1.0 / gamma));

    final_color = vec4(mapped, 1.0);
}